/* Tabela CODTRIBSAP: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela CODTRIBSAP */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela CODTRIBSAP, utilizando
a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_ADM_CODTRIBSAP
AFTER DELETE OR INSERT OR UPDATE
ON CODTRIBSAP FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   IF DELETING THEN

      IF :OLD.CDEMPRESA IS NOT NULL THEN
         V_DESC := V_DESC || 'Empresa=' || :OLD.CDEMPRESA;
      END IF;

      IF :OLD.IDENTRSAIDOP IS NOT NULL THEN
         V_DESC := V_DESC || ' E/S=' || :OLD.IDENTRSAIDOP;
      END IF;

      IF :OLD.CDTIPOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' TpOper=' || :OLD.CDTIPOOPER;
      END IF;

      IF :OLD.CDINSCESTA IS NOT NULL THEN
         V_DESC := V_DESC || ' Insc=' || :OLD.CDINSCESTA;
      END IF;

      IF :OLD.CDFISCSAP IS NOT NULL THEN
         V_DESC := V_DESC || ' CodFisc=' || :OLD.CDFISCSAP;
      END IF;

      IF :OLD.CDCSTSAP IS NOT NULL THEN
         V_DESC := V_DESC || ' SitTrib=' || :OLD.CDCSTSAP;
      END IF;

      IF :OLD.CDTRIBSDX IS NOT NULL THEN
         V_DESC := V_DESC || ' CodTribSAP=' || :OLD.CDTRIBSDX;
      END IF;

      V_DESC := V_DESC || ' Produto=' || :OLD.CDPRODUTO;


      V_TIPO         := '3';
      V_ITPESQ       := :OLD.NRCODTRIBSAP;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.CDEMPRESA,'!')    <> NVL(:NEW.CDEMPRESA,'!'))    OR
            (NVL(:OLD.IDENTRSAIDOP,'!') <> NVL(:NEW.IDENTRSAIDOP,'!')) OR
            (NVL(:OLD.CDTIPOOPER,'!')   <> NVL(:NEW.CDTIPOOPER,'!'))   OR
            (NVL(:OLD.CDINSCESTA,'!')   <> NVL(:NEW.CDINSCESTA,'!'))   OR
            (NVL(:OLD.CDFISCSAP,'!')    <> NVL(:NEW.CDFISCSAP,'!'))    OR
            (NVL(:OLD.CDCSTSAP,'!')     <> NVL(:NEW.CDCSTSAP,'!'))     OR
            (NVL(:OLD.CDTRIBSDX,'!')    <> NVL(:NEW.CDTRIBSDX,'!'))    OR
            (NVL(:OLD.CDPRODUTO,'!')    <> NVL(:NEW.CDPRODUTO,'!'))    THEN

            IF (NVL(:OLD.CDEMPRESA,'!')    <> NVL(:NEW.CDEMPRESA,'!')) THEN
               V_DESC := V_DESC || 'Empresa=' || :NEW.CDEMPRESA;
            END IF;

            IF (NVL(:OLD.IDENTRSAIDOP,'!') <> NVL(:NEW.IDENTRSAIDOP,'!')) THEN
               V_DESC := V_DESC || 'E/S=' || :NEW.IDENTRSAIDOP;
            END IF;

            IF (NVL(:OLD.CDTIPOOPER,'!')   <> NVL(:NEW.CDTIPOOPER,'!')) THEN
               V_DESC := V_DESC || ' TpOper=' || :NEW.CDTIPOOPER;
            END IF;

            IF (NVL(:OLD.CDINSCESTA,'!')   <> NVL(:NEW.CDINSCESTA,'!')) THEN
               V_DESC := V_DESC || ' Insc=' || :NEW.CDINSCESTA;
            END IF;

            IF (NVL(:OLD.CDFISCSAP,'!')    <> NVL(:NEW.CDFISCSAP,'!')) THEN
               V_DESC := V_DESC || ' CodFisc=' || :NEW.CDFISCSAP;
            END IF;

            IF (NVL(:OLD.CDCSTSAP,'!')     <> NVL(:NEW.CDCSTSAP,'!')) THEN
               V_DESC := V_DESC || ' SitTrib=' || :NEW.CDCSTSAP;
            END IF;

            IF (NVL(:OLD.CDTRIBSDX,'!')    <> NVL(:NEW.CDTRIBSDX,'!')) THEN
               V_DESC := V_DESC || ' CodTribSAP=' || :NEW.CDTRIBSDX;
            END IF;

            IF (NVL(:OLD.CDPRODUTO,'!')    <> NVL(:NEW.CDPRODUTO,'!')) THEN
               V_DESC := V_DESC || ' Produto=' || :NEW.CDPRODUTO;
            END IF;

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.NRCODTRIBSAP;
         END IF;
      ELSE
         IF :NEW.CDEMPRESA IS NOT NULL THEN
            V_DESC := V_DESC || 'Empresa=' || :NEW.CDEMPRESA;
         END IF;

         IF :NEW.IDENTRSAIDOP IS NOT NULL THEN
            V_DESC := V_DESC || 'E/S=' || :NEW.IDENTRSAIDOP;
         END IF;

         IF :NEW.CDTIPOOPER IS NOT NULL THEN
            V_DESC := V_DESC || ' TpOper=' || :NEW.CDTIPOOPER;
         END IF;

         IF :NEW.CDINSCESTA IS NOT NULL THEN
            V_DESC := V_DESC || ' Insc=' || :NEW.CDINSCESTA;
         END IF;

         IF :NEW.CDFISCSAP IS NOT NULL THEN
            V_DESC := V_DESC || ' CodFisc=' || :NEW.CDFISCSAP;
         END IF;

         IF :NEW.CDCSTSAP IS NOT NULL THEN
            V_DESC := V_DESC || ' SitTrib=' || :NEW.CDCSTSAP;
         END IF;

         IF :NEW.CDTRIBSDX IS NOT NULL THEN
            V_DESC := V_DESC || ' CodTribSAP=' || :NEW.CDTRIBSDX;
         END IF;

         IF (NVL(:OLD.CDPRODUTO,'!')    <> NVL(:NEW.CDPRODUTO,'!')) THEN
            V_DESC := V_DESC || ' Produto=' || :NEW.CDPRODUTO;
         END IF;

         V_TIPO         := '1';
         V_ITPESQ       := :NEW.NRCODTRIBSAP;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('CODTRIBSAP',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_ADM_CODTRIBSAP','4.09.060'); END;
/

